package cn.estsh.i3plus.pojo.wms.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

/**
 * @Description : 供应商
 * @Reference :
 * @Author : amy
 * @CreateDate : 2018-11-07 14:21
 * @Modify:
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name="BAS_VENDOR")
@Api("供应商")
public class BasVendor extends BaseBean{

    @Column(name="VENDOR_NO")
    @ApiParam("供应商编号")
    private String vendorNo;

    @Column(name="VENDOR_NAME")
    @ApiParam("供应商简称")
    private String vendorName;

    @Column(name="VENDOR_DESC")
    @ApiParam("供应商全称")
    private String vendorDesc;

    @Column(name="VENDOR_ADDR")
    @ApiParam("供应商地址")
    private String vendorAddr;

    @Column(name="VENDOR_OWNER")
    @ApiParam("联系人")
    private String vendorOwner;

    @Column(name="VENDOR_EMAIL")
    @ApiParam("邮箱")
    private String vendorEmail;

    @Column(name = "IS_ASN")
    @ApiParam(value = "是否发ASN", example = "0")
    private Integer isAsn;

    @Column(name = "USER_NAME")
    @ApiParam(value = "用户名")
    private String userName;

    @Column(name = "PASSWORD")
    @ApiParam(value = "密码")
    private String password;
}